VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsColoredListbox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    =======================================
'          Graphical ListBox Control
'            with Horizontal Scroll
'
'              Version 2.00 Alpha
'
'    =======================================
'
'     History:
'     Version 1.00 by Alexander Popov Emulation Soft. 7.2002
'
'     Version 2.00 by Daniel Aue, 12.2003
'     reusable Class Version for capturing external PicBoxes,
'     supports now 24bpp Color, integrated Scrollbars, Speed Optimized,
'     highlight graphical support, keyboard support, sorting, and many more
'
'  Use at your own Risk
'
'  To use color code add the 24 Bit Blue/Green/Red Hex Number between two "\" 's
'  for example:
'     "\33AAFF\Hello"
'  This will give the word "Hello" in an orange color.
'  use "\\" for a "\" sign
'=======================================


Option Explicit
Option Base 0


'for fast Scrolling with ScrollDC:
Private Declare Function API_DeleteObject Lib "gdi32" Alias "DeleteObject" _
        (ByVal hObject As Long) As Long

Private Declare Function API_ScrollDC Lib "user32.dll" Alias "ScrollDC" _
        (ByVal hdc As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As Any, _
        lprcClip As Any, ByVal hrgnUpdate As Long, lprcUpdate As RECT) As Long

Private Declare Function API_FillRect Lib "user32.dll" Alias "FillRect" _
        (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long

Private Declare Function API_CreateSolidBrush Lib "gdi32" Alias "CreateSolidBrush" _
        (ByVal crColor As Long) As Long

Private Declare Function API_GetSysColor Lib "user32" Alias "GetSysColor" _
        (ByVal nIndex As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
'for fast Scrolling with API_ScrollDC END



'for drawing the selector:
Private Declare Function API_BitBlt Lib "gdi32.dll" Alias "BitBlt" _
        (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
        ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Private Declare Function API_CreateCompatibleDC Lib "gdi32.dll" Alias _
        "CreateCompatibleDC" (ByVal hdc As Long) As Long

Private Declare Function API_DeleteDC Lib "gdi32.dll" Alias "DeleteDC" _
        (ByVal hdc As Long) As Long

Private Declare Function API_SelectObject Lib "gdi32.dll" Alias "SelectObject" _
        (ByVal hdc As Long, ByVal hObject As Long) As Long
'for drawing the selector END



'for scrollbars:
Private Declare Function API_ShowScrollBar Lib "user32.dll" Alias "ShowScrollBar" _
        (ByVal hwnd As Long, ByVal wBar As Long, ByVal bShow As Long) As Long

Private Declare Function API_GetScrollInfo Lib "user32.dll" Alias "GetScrollInfo" _
        (ByVal hwnd As Long, ByVal n As Long, lpScrollInfo As SCROLLINFO) As Long

Private Declare Function API_SetScrollInfo Lib "user32.dll" Alias "SetScrollInfo" _
        (ByVal hwnd As Long, ByVal n As Long, lpcScrollInfo As SCROLLINFO, _
        ByVal bool As Boolean) As Long

Private Type SCROLLINFO
   cbSize As Long
   fMask As Long
   nMin As Long
   nMax As Long
   nPage As Long
   nPos As Long
   nTrackPos As Long
End Type

Private Const SIF_PAGE As Long = &H2
Private Const SIF_RANGE As Long = &H1
Private Const SIF_TRACKPOS As Long = &H10
Private Const SIF_POS As Long = &H4
Private Const SIF_ALL As Long = (SIF_RANGE Or SIF_PAGE Or SIF_POS Or SIF_TRACKPOS)

Private Enum SB_BARDEF
   SB_HORZ = 0
   SB_VERT = 1
   SB_BOTH = 3
End Enum

Private Const SB_LINEDOWN = 1
Private Const SB_LINELEFT = 0
Private Const SB_LINERIGHT = 1
Private Const SB_LINEUP = 0
Private Const SB_PAGEDOWN = 3
Private Const SB_PAGELEFT = 2
Private Const SB_PAGERIGHT = 3
Private Const SB_PAGEUP = 2
Private Const SB_THUMBTRACK = 5
Private Const SB_LEFT = 6
Private Const SB_RIGHT = 7
Private Const SB_TOP = 6
Private Const SB_BOTTOM = 7
Private Const SB_ENDSCROLL = 8
'for scrollbars END


'for fast removement of Item
Private Declare Sub API_CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" _
        (ByVal lpDestination As Long, ByVal lpSource As Long, ByVal Length As Long)


Private Const VK_DOWN As Long = &H28
Private Const VK_UP As Long = &H26
Private Const VK_LEFT As Long = &H25
Private Const VK_RIGHT As Long = &H27

'#### ##  ##  ###  ## ##  #### ## ##        ###  ####  ##
'##   ### ## ## ## ## ## ##    ## ##       ## ## ## ## ##
'###  ### ## ## ## ## ## ## ## #####       ##### ####  ##
'##   ## ### ## ## ## ## ##  # ## ##       ## ## ##    ##
'#### ##  ##  ###   ###   #### ## ##       ## ## ##    ##


' ===== list properties ============:
'for handling the list we've got these:
Dim oList() As clsItem   'takes the list
Dim lReservedMem As Long

Dim iListCount As Integer  'Number of Elements
Dim iTopIndex As Integer   'Top Element in current Display
Dim iListIndex As Integer     'currently highlit element


'for reducing repaint effort we've got to remember the previous state
Dim iOldListCount As Integer
Dim iOldTopIndex As Integer
Dim iOldListIndex As Integer


' visible area scrollers excluded:
Dim iWorkingWidth As Integer
Dim iWorkingHeight As Integer

' Client Window area (scrollers included):
Dim iClientWidth As Integer
Dim iClientHeight As Integer


'remember the Textwidth of the longest text in the list,
'for calculation of H Scroll Maximum:
Dim lMaxLength As Long

'Is there a H Scroller at all ?
Dim bHScrollerVisible As Boolean

'currently Horizontal Scroll Position
Dim lHScrPos As Long
Dim lOldHScrPos As Long


'size of one char
Dim iCharWidth As Integer
Dim iCharHeight As Integer

'default text color
Dim ClientForeColor As Long
Dim ClientBackColor As Long


'user defined highlight color
Public HighlightColor As Long
'=====================================


Dim picHighlight As StdPicture
Dim picClient As PictureBox

Dim hBrush As Long
Dim hdc As Long

Public Enum SortCriteria
   CListSortByText
   CListSortByTag
End Enum

'####  ####   ###  ####  #### ####  ###### ## ####  ###
'## ## ## ## ## ## ## ## ##   ## ##   ##   ## ##   ##
'####  ####  ## ## ####  ###  ####    ##   ## ###   ##
'##    ## ## ## ## ##    ##   ## ##   ##   ## ##     ##
'##    ## ##  ###  ##    #### ## ##   ##   ## #### ###
Property Get CurrentPicBox() As Object
   Set CurrentPicBox = picClient
End Property

Property Get ListIndex() As Long
   'index of the currently selected element
   ListIndex = iListIndex
End Property

Property Let ListIndex(Value As Long)
   If Value >= 0 And Value < iListCount Then
      iListIndex = Value
      UpdateDisplay
   Else
      Err.Raise 380
   End If
End Property

Property Get List(Index As Long) As clsItem
   'returns the required element
   If Index < 0 Or Index > iListCount - 1 Then
      Set List = Nothing
   Else
      Set List = oList(Index)
   End If
End Property

Property Get SelectedItem() As clsItem
   If iListIndex <> -1 Then
      Set SelectedItem = oList(iListIndex)
   Else
      Set SelectedItem = Nothing
   End If
End Property

Property Get ListCount() As Long
   ListCount = iListCount
End Property

Property Get Version() As String
   Version = "2.00 Beta"
End Property

Property Get TopIndex() As Long
   TopIndex = iTopIndex
End Property

Property Let TopIndex(ByVal Value As Long)
   If Value >= 0 And Value < iListCount Then
      If Value > iListCount - Int(iWorkingHeight / iCharHeight) Then
         Value = iListCount - Int(iWorkingHeight / iCharHeight)
         If Value < 0 Then
            Value = 0
         End If
      End If
      iTopIndex = Value
      SetScroll SB_VERT, Value
      UpdateDisplay
   Else
      Err.Raise 380
   End If
End Property

Property Get Text() As String
   If Not iListIndex = -1 Then
      Text = oList(iListIndex).Text
   End If
End Property

' ###  ##    ###   ###  ###       ## ##  ###  ##  ## ####  ##   ## ##  ##  ####
'## ## ##   ## ## ##   ##         ## ## ## ## ### ## ## ## ##   ## ### ## ##
'##    ##   #####  ##   ##        ##### ##### ### ## ## ## ##   ## ### ## ## ##
'## ## ##   ## ##   ##   ##       ## ## ## ## ## ### ## ## ##   ## ## ### ##  #
' ###  #### ## ## ###  ###        ## ## ## ## ##  ## ####  #### ## ##  ##  ####


Private Sub Class_Initialize()
    Erase oList
    
    iListCount = 0
    iOldListCount = 0
    
    iTopIndex = 0
    iOldTopIndex = 0
    
    iListIndex = -1
    iOldListIndex = -1

End Sub


Private Sub Class_Terminate()
   Me.Release
End Sub


Public Sub Connect(PicBox As Object, Optional HighlightPic As StdPicture)
   On Error GoTo connect_error
   Me.Release  'just in case of a reconnect
   
   Set picClient = PicBox
   picClient.AutoRedraw = False
   picClient.ScaleMode = vbPixels
   
   'further calls to .scaleheight/width may give different results,
   'because of visible scrollbars. so store the full window size:
   iClientHeight = picClient.ScaleHeight
   iClientWidth = picClient.ScaleWidth
   
   ClientForeColor = picClient.ForeColor
   ClientBackColor = picClient.BackColor
   
   'subclass the window for scrollbar messages
'   Resize
'   API_ShowScrollBar picClient.hwnd, SB_BOTH, 1
   Subclass picClient.hwnd, Me   'set hook
   
   
   'create Brush for refreshing line after API_ScrollDC
   If ClientBackColor < 0 Then
      hBrush = API_CreateSolidBrush(API_GetSysColor(ClientBackColor And &HFFFF&))
   Else
      hBrush = API_CreateSolidBrush(ClientBackColor)
   End If
   
   Set picHighlight = HighlightPic
   If Not picHighlight Is Nothing Then
      'for BitBlt:
      hdc = API_CreateCompatibleDC(picClient.hdc)
      API_SelectObject hdc, picHighlight.Handle
   End If

   
    ' Assumed that we are using fixed font:
    iCharWidth = picClient.TextWidth("W")
    iCharHeight = picClient.TextHeight("W")
   
   RecalculateMaxHScroll   'we've got a new font now
   AdjustScrollers
   picClient.Refresh 'cause a repaint

connect_error:
   Select Case Err.Number
   Case 0
   Case Else
      Err.Raise Err.Number, , "This Picturebox is allready connected to a ColoredListbox object !"
   End Select
End Sub

Public Sub Release()
   If Not picClient Is Nothing Then
      'remove scrollbars
      API_ShowScrollBar picClient.hwnd, SB_BOTH, 0
      Subclass picClient.hwnd, Me, True 'release hook
   
      picClient.ForeColor = ClientForeColor
   
      'clean up GDI Objects
      Call API_DeleteObject(hBrush)
      Call API_DeleteDC(hdc)
      picClient.Refresh
      Set picClient = Nothing
   End If
End Sub



'####  ## ## ####  ##   ##  ###        #### ## ## ##  ##  ###  ###### ##  ###  ##  ##  ###
'## ## ## ## ## ## ##   ## ## ##       ##   ## ## ### ## ## ##   ##   ## ## ## ### ## ##
'####  ## ## ####  ##   ## ##          ###  ## ## ### ## ##      ##   ## ## ## ### ##  ##
'##    ## ## ## ## ##   ## ## ##       ##   ## ## ## ### ## ##   ##   ## ## ## ## ###   ##
'##     ###  ####  #### ##  ###        ##    ###  ##  ##  ###    ##   ##  ###  ##  ## ###
Public Sub Sort(SortCriteria As SortCriteria, Optional Descending As Boolean = False)
   'to do: provide sorting via normal Listbox Properties
   Dim x As Long
   Dim sTagTypeName As String
   Dim oTempList() As clsItem
   
   If iListCount = 0 Then
      Exit Sub 'sort only if there is data
   End If
   
   If SortCriteria = CListSortByTag Then
      'check if tags are consistent and no objects
      If IsObject(oList(0).Tag) Then
         Err.Raise 1, , "Cant sort by Tag's that are Objects !"
      End If
      
      sTagTypeName = TypeName(oList(0).Tag)
      For x = 0 To iListCount - 1
         If TypeName(oList(x).Tag) <> sTagTypeName Then
            Err.Raise 1, , "Tag's are different datatypes or some Tag's are missing ! " & vbCrLf & "Cant sort by Tag."
         End If
      Next
   End If
   'do the sort now
   Call VBQuickSort(oList(), 0, iListCount - 1, SortCriteria)
   
   'correct index
   If Descending Then
      'this is fast but need's more memory:
      ReDim oTempList(UBound(oList))
      For x = 0 To iListCount - 1
         Set oTempList(x) = oList(iListCount - 1 - x)
         oTempList(x).SetIndex x
      Next
      oList = oTempList
   Else
      For x = 0 To iListCount - 1
         oList(x).SetIndex x
      Next
   End If
   
   If Not picClient Is Nothing Then
      picClient.Refresh 'force a repaint
   End If
End Sub


Public Sub AddItem(sItem As String, Optional Tag As Variant = Nothing)
   Dim iTW As Integer
   Dim iSC As Integer
   Dim sTemp As String
   Dim i As Integer
   Dim oNewEntry As clsItem
         
   'for speed: reserve in blocks of 100 to avoid rediming on consecutive calls
   If iListCount = lReservedMem Then
      ReDim Preserve oList(0 To iListCount + 100)
      lReservedMem = UBound(oList)
   End If
    
   Set oNewEntry = New clsItem
   
   With oNewEntry
      .SetParent Me
      .SetIndex iListCount
      .SetColorText sItem
      If IsObject(Tag) Then
         Set .Tag = Tag
      Else
         .Tag = Tag
      End If
   End With

   Set oList(iListCount) = oNewEntry
   iListCount = iListCount + 1
    
   If Not picClient Is Nothing Then 'still taking Items, even if we're not connected
      If picClient.TextWidth(oNewEntry.Text) / iCharWidth > lMaxLength Then
         lMaxLength = picClient.TextWidth(oNewEntry.Text) / iCharWidth
      End If
      
      AdjustScrollers
      UpdateDisplay
   End If
    
   Set oNewEntry = Nothing
End Sub


Public Sub RemoveItem(Index As Long)
   Dim oItem As clsItem
   Dim x As Long
   Dim r As RECT
   Dim rScroll As RECT
   Dim lBottomIndex As Long
   
   Set oItem = oList(Index)
   
   'zap item:
   Set oList(Index) = Nothing
   API_CopyMemory VarPtr(oList(Index)), VarPtr(oList(Index + 1)), (iListCount - 1 - Index) * 4
   x = 0
   API_CopyMemory VarPtr(oList(iListCount - 1)), VarPtr(x), 4 'zap double reference
   iListCount = iListCount - 1
   iOldListCount = iListCount
   'correct index:
   For x = Index To iListCount - 1
      oList(x).SetIndex (x)
   Next
   
   'have we removed the selected item ?
   If iListIndex = Index Then
      iListIndex = -1
      iOldListIndex = iListIndex
   End If
   
   If picClient.TextWidth(oItem.Text) / iCharWidth = lMaxLength Then
      'we removed the largest entry->find the next less largest
      RecalculateMaxHScroll
   End If
   
   AdjustScrollers
   
   If Index >= iTopIndex And _
      Index <= iTopIndex + Int(iWorkingHeight / iCharHeight) Then
      'removed item is in visible area:
      If picClient.Picture <> 0 Then
         'If we've got a background image then reprint the whole list:
         picClient.Refresh 'causes a call to HandlePaintEvent via WM_PAINT Message
      Else
         'fast scrolling via API_ScrollDC. Not usabel with Background Image:
         rScroll.Right = iWorkingWidth
         rScroll.Bottom = iWorkingHeight
         rScroll.Top = (Index - iTopIndex + 1) * iCharHeight
         API_ScrollDC picClient.hdc, 0, -iCharHeight, rScroll, ByVal 0&, ByVal 0&, r
         Call API_FillRect(picClient.hdc, r, hBrush)
         lBottomIndex = iTopIndex + Int(iWorkingHeight / iCharHeight) - 1
         If lBottomIndex <= iListCount - 1 Then
            UpdateDisplay (lBottomIndex)  'refresh last fully visible line
            If lBottomIndex + 1 <= iListCount - 1 Then
               UpdateDisplay (lBottomIndex + 1) 'refresh last (truncated) line
            End If
         End If
      End If

   End If
End Sub

Public Sub Clear()
   ReDim oList(0)
   iListCount = 0
   lReservedMem = 1
   iTopIndex = 0
   iListIndex = -1
   picClient.Refresh
End Sub

'####  ####  ## ## ##  ###  ###### ####       #### ## ## ##  ##  ###  ###### ##  ###  ##  ##  ###
'## ## ## ## ## ## ## ## ##   ##   ##         ##   ## ## ### ## ## ##   ##   ## ## ## ### ## ##
'####  ####  ## ## ## #####   ##   ###        ###  ## ## ### ## ##      ##   ## ## ## ### ##  ##
'##    ## ## ##  ###  ## ##   ##   ##         ##   ## ## ## ### ## ##   ##   ## ## ## ## ###   ##
'##    ## ## ##   #   ## ##   ##   ####       ##    ###  ##  ##  ###    ##   ##  ###  ##  ## ###

Friend Sub UpdateDisplay(Optional IndexChanged As Long = -1)
'updates the display with more or less effort, depending on the change
   'to do: put ScrollH and ScrollV code into seperate Functions
   'to make it more readable
   Dim r As RECT
   Dim x As Long
   Dim lDisplacement As Long
   Dim iOldBottom As Integer
   Dim iNewBottom As Integer
   Dim iCurrentX As Single
   
   If IndexChanged <> -1 Then
      
      If IndexChanged >= iTopIndex And _
         IndexChanged <= iTopIndex + Int(iWorkingHeight / iCharHeight) Then
         'IndexChanged is in visible Area-> repaint it
         picClient.CurrentX = -lHScrPos * iCharWidth
         picClient.CurrentY = (IndexChanged - iTopIndex) * iCharHeight
         remove_SELECTOR   'clear line
         If iListIndex = IndexChanged Then
            draw_SELECTOR
         End If
         print_in_COLOR oList(IndexChanged).ColorText
      End If

   ElseIf iOldTopIndex <> iTopIndex Then
      
      'scrolled Verically
      If picClient.Picture <> 0 Then
         'If we've got a background image then reprint the whole list:
         picClient.Refresh 'causes a call to HandlePaintEvent via WM_PAINT Message
         'to do: drawing into a Backbuffer to avoid flickering of Display
      Else
         'fast scrolling via API_ScrollDC. Not usabel with Background Image:
         lDisplacement = iOldTopIndex - iTopIndex
         lDisplacement = lDisplacement * iCharHeight
         API_ScrollDC picClient.hdc, 0, lDisplacement, ByVal 0&, ByVal 0&, ByVal 0&, r
         Call API_FillRect(picClient.hdc, r, hBrush)
        
         'print new lines
         iOldBottom = iOldTopIndex + Int(iWorkingHeight / iCharHeight - 1) + 1
         iNewBottom = iTopIndex + Int(iWorkingHeight / iCharHeight - 1) + 1
         If iNewBottom >= iListCount Then
            iNewBottom = iListCount - 1
         End If

         iCurrentX = -lHScrPos * iCharWidth
         For x = iTopIndex To iNewBottom
            If x >= iOldBottom Or x < iOldTopIndex Then   'was it ScrollDC'ed ?
               'no: reprint the line
               picClient.CurrentX = iCurrentX
               picClient.CurrentY = (x - iTopIndex) * iCharHeight
               If iListIndex = x Then
                  draw_SELECTOR
               End If
               print_in_COLOR oList(x).ColorText
            End If
         Next
      End If

      iOldTopIndex = iTopIndex
'*******************************************************************************
   ElseIf lOldHScrPos <> lHScrPos Then
            'scrolled Horizontal
      If picClient.Picture <> 0 Then

         'If we've got a background image then reprint the whole list:
         picClient.Refresh 'causes a call to HandlePaintEvent via WM_PAINT Message
         'to do: drawing into a Backbuffer to avoid flickering of Display
      Else
         'fast scrolling via API_ScrollDC. Not usabel with Background Image:
         lDisplacement = lOldHScrPos - lHScrPos
         lDisplacement = lDisplacement * iCharWidth
         API_ScrollDC picClient.hdc, lDisplacement, 0, ByVal 0&, ByVal 0&, ByVal 0&, r
         Call API_FillRect(picClient.hdc, r, hBrush)
        
         'print new lines
         iNewBottom = iTopIndex + Int(iWorkingHeight / iCharHeight - 1) + 1
         If iNewBottom >= iListCount Then
            iNewBottom = iListCount - 1
         End If

         For x = iTopIndex To iNewBottom
            picClient.CurrentX = -lHScrPos * iCharWidth
            picClient.CurrentY = (x - iTopIndex) * iCharHeight
            If iListIndex = x Then
               draw_SELECTOR
            End If
            print_in_COLOR oList(x).ColorText
         Next
      End If

      lOldHScrPos = lHScrPos

      
   ElseIf iOldListIndex <> iListIndex Then
   
      '***** rehighlight ******
      If iOldListIndex <> -1 And _
         iOldListIndex >= iTopIndex And _
         iOldListIndex <= iTopIndex + Int(iWorkingHeight / iCharHeight) Then
         'old selector is in visible Area-> remove it
         picClient.CurrentX = -lHScrPos * iCharWidth
         picClient.CurrentY = (iOldListIndex - iTopIndex) * iCharHeight
         remove_SELECTOR
         print_in_COLOR oList(iOldListIndex).ColorText
      End If
      If iListIndex <> -1 And _
         iListIndex >= iTopIndex And _
         iListIndex <= iTopIndex + Int(iWorkingHeight / iCharHeight) Then
         'new selector is in visible Area-> draw it
         picClient.CurrentX = -lHScrPos * iCharWidth
         picClient.CurrentY = (iListIndex - iTopIndex) * iCharHeight
         draw_SELECTOR
         print_in_COLOR oList(iListIndex).ColorText
      End If
      
      iOldListIndex = iListIndex
      
      
   ElseIf iOldListCount < iListCount Then
   
      '***** ADD new element at the bottom line ******
      iNewBottom = iTopIndex + Int(iWorkingHeight / iCharHeight) + 1
      If iNewBottom >= iListCount Then
         picClient.CurrentX = -lHScrPos * iCharWidth
         picClient.CurrentY = (iListCount - iTopIndex - 1) * iCharHeight
         print_in_COLOR oList(iListCount - 1).ColorText
      End If
      iOldListCount = iListCount
   
   End If
    
End Sub

Private Sub RecalculateMaxHScroll()
'In case of a (re)connect to a picBox with a allready filled List, the
'lMaxLength (TextWidth of the longest List Entry) needs to be recalculated
'because of different Font/Fontsize
'This is what this Function does.
   'to do: improve speed for *really* long lists
   Dim x As Long
   Dim lThisTextWidth As Long
   Dim r As RECT
   Dim sTemp As String
   
   lMaxLength = 0
   For x = 0 To iListCount - 1
      lThisTextWidth = picClient.TextWidth((oList(x).Text)) / iCharWidth
      
      If lThisTextWidth > lMaxLength Then
         lMaxLength = lThisTextWidth
      End If
   Next
End Sub


Private Sub AdjustScrollers()
'this function decides which scrollers we need by
'comparing lMaxLength to the number of visible chars and
'comparing iListCount to visible lines.
'hides or shows the scrollbars, sets the max and page size's and
'recalculates iWorkingWidth and iWorkingHeight (width and Height
'could have changed, because of now visible/invisible Scrollbars) by
'calling Me.Resize

   Dim udtScrInfo As SCROLLINFO
   Dim lVisibleLines As Long
   Dim lVisibleChars As Long
   
   'decide which scrollers we need
   lVisibleChars = Int(iClientWidth / iCharWidth)
   If lVisibleChars <= lMaxLength Then
      API_ShowScrollBar picClient.hwnd, SB_HORZ, 1 'show scroller
      bHScrollerVisible = True
   Else
      API_ShowScrollBar picClient.hwnd, SB_HORZ, 0 'hide scroller
      bHScrollerVisible = False
   End If
   
   lVisibleLines = Int(picClient.ScaleHeight / iCharHeight)
   If lVisibleLines <= iListCount Then
      'review hscroll decision now:
      API_ShowScrollBar picClient.hwnd, SB_VERT, 1 'show scroller
      lVisibleChars = Int(picClient.ScaleWidth / iCharWidth)
      If lVisibleChars <= lMaxLength Then
         API_ShowScrollBar picClient.hwnd, SB_HORZ, 1 'show scroller
         bHScrollerVisible = True
      End If
   Else
      API_ShowScrollBar picClient.hwnd, SB_VERT, 0 'hide scroller
   End If
   'decide which scrollers we need END
   
   
   'adjust Vertical Scroller:
   lVisibleLines = Int(picClient.ScaleHeight / iCharHeight)
   If lVisibleLines > iListCount Then
      lVisibleLines = iListCount
   End If
   With udtScrInfo
      .cbSize = LenB(udtScrInfo)
      .nMin = 0
      .nMax = iListCount - 1
      .nPage = lVisibleLines
      .fMask = SIF_PAGE Or SIF_RANGE
   End With
   API_SetScrollInfo picClient.hwnd, SB_VERT, udtScrInfo, 1
   
   'adjust Horizontal Scroller:
   lVisibleChars = Int(picClient.ScaleWidth / iCharWidth)
   If lVisibleChars > lMaxLength Then
      lVisibleChars = lMaxLength
   End If
   With udtScrInfo
      .cbSize = LenB(udtScrInfo)
      .nMin = 0
      .nMax = lMaxLength - 1
      .nPage = lVisibleChars
      .fMask = SIF_PAGE Or SIF_RANGE
   End With
   API_SetScrollInfo picClient.hwnd, SB_HORZ, udtScrInfo, 1
   
   Resize   'recalculate working area
End Sub

Private Sub SetScroll(Which As SB_BARDEF, ByVal Value As Long)
'sets the Scroller to a specified Position
   Dim udtScrInfo As SCROLLINFO
   With udtScrInfo
      .cbSize = LenB(udtScrInfo)
      .fMask = SIF_POS
      .nPos = Value
   End With
   API_SetScrollInfo picClient.hwnd, Which, udtScrInfo, True
End Sub



Friend Function remove_ALL_COLOR_DATA(sExpr As String) As String
' this function parses the string the same way as
' print_in_COLOR() does, and returns string without any
' controlling characters:

Dim sExprArray() As String
Dim sTemp As String
Dim bNextIsColor As Boolean
Dim sResult As String
Dim x As Integer

   sExprArray = Split(sExpr, "\")

   For x = 0 To UBound(sExprArray)
      sTemp = sExprArray(x)
      If Len(sTemp) = 0 Then
         If bNextIsColor = False Then
            bNextIsColor = True
         Else
            bNextIsColor = False
            sResult = sResult & "\" 'was "\\"
         End If
      Else
         If bNextIsColor = False Then
            sResult = sResult & sTemp
            bNextIsColor = True
         Else
            bNextIsColor = False
         End If
      End If
   Next
   
   remove_ALL_COLOR_DATA = sResult
End Function



'#### ## ## #### ##  ## ######       ## ##  ###  ##  ## ####  ##   ## ##  ##  ####
'##   ## ## ##   ### ##   ##         ## ## ## ## ### ## ## ## ##   ## ### ## ##
'###  ## ## ###  ### ##   ##         ##### ##### ### ## ## ## ##   ## ### ## ## ##
'##    ###  ##   ## ###   ##         ## ## ## ## ## ### ## ## ##   ## ## ### ##  #
'####   #   #### ##  ##   ##         ## ## ## ## ##  ## ####  #### ## ##  ##  ####

Public Sub HandleResizeEvent()
Attribute HandleResizeEvent.VB_MemberFlags = "40"
   API_ShowScrollBar picClient.hwnd, SB_BOTH, 0 'hide both
   iClientHeight = picClient.ScaleHeight
   iClientWidth = picClient.ScaleWidth
   AdjustScrollers
   HandlePaintEvent ' picClient.Refresh does not work here because of rekursive calls to MyProc
End Sub



Public Sub Resize()
   iWorkingHeight = picClient.ScaleHeight
   iWorkingWidth = picClient.ScaleWidth
End Sub
         
Public Sub HandleMouseEvents(wParam As Long, lParam As Long)
Attribute HandleMouseEvents.VB_MemberFlags = "40"
'this is executed when recieving WM_MOUSEMOVE message and left button is down, or when
'recieving a WM_LBUTTONDOWN Message
   Dim iTEMP As Integer
   Dim iPosX As Long
   Dim iPosY As Long
   
   iPosY = (lParam And &HFFFF0000) / &H10000
   iPosX = lParam And &HFFFF&
   
   If iPosY < 0 Then
      iPosY = 0
      
      'ScrollUpOneLine
      If iTopIndex > 0 Then
         iTopIndex = iTopIndex - 1
         SetScroll SB_VERT, iTopIndex
         UpdateDisplay
      End If

   ElseIf iPosY > iWorkingHeight Then
      iPosY = iWorkingHeight
      
      'ScrollDownOneLine
      If iTopIndex + Int(iWorkingHeight \ iCharHeight) < iListCount Then
         iTopIndex = iTopIndex + 1
         SetScroll SB_VERT, iTopIndex
         UpdateDisplay
      End If
   End If
      
   iTEMP = Fix(iPosY / iCharHeight)

   iTEMP = iTEMP + iTopIndex

   If iTEMP < iListCount Then
      iListIndex = iTEMP
      UpdateDisplay  'redraw selector
   End If

End Sub

Public Sub HandleKeyboardEvents(wParam As Long, lParam As Long)
Attribute HandleKeyboardEvents.VB_MemberFlags = "40"
   'this is executed when a WM_KEYDOWN Message is recieved
   
   Select Case wParam
   Case VK_DOWN, VK_UP
      'handle up/down only if there is an item selected:
      If iListIndex <> -1 Then
         'change selected item:
         If wParam = VK_DOWN And iListIndex < iListCount - 1 Then
            iListIndex = iListIndex + 1
         ElseIf wParam = VK_UP And iListIndex > 0 Then
            iListIndex = iListIndex - 1
         End If
               
         'scroll to slected item if necessary:
         If iListIndex >= iTopIndex Then
            If iListIndex <= iTopIndex + Int(iWorkingHeight / iCharHeight) - 1 Then
               'no scroll needed
               UpdateDisplay
            Else
               'scroll down
               UpdateDisplay ' rehighlight
               iTopIndex = iListIndex - Int(iWorkingHeight / iCharHeight) + 1
               SetScroll SB_VERT, iTopIndex
               UpdateDisplay
            End If
         Else
            'scroll up
            UpdateDisplay ' rehighlight
            iTopIndex = iListIndex
            SetScroll SB_VERT, iTopIndex
            UpdateDisplay
         End If
      End If
   
   Case VK_LEFT, VK_RIGHT
      'handle left/right only if horizontal scroller is visible
      If bHScrollerVisible Then
         If wParam = VK_RIGHT And lHScrPos < lMaxLength - Int(picClient.ScaleWidth / iCharWidth) Then
            lHScrPos = lHScrPos + 1
         ElseIf wParam = VK_LEFT And lHScrPos > 0 Then
            lHScrPos = lHScrPos - 1
         End If
         SetScroll SB_HORZ, lHScrPos
         UpdateDisplay
      End If
   Case Else
   End Select
End Sub


Public Sub HandleVScrollEvents(wParam As Long, lParam As Long)
Attribute HandleVScrollEvents.VB_MemberFlags = "40"
   Dim udtScrInfo As SCROLLINFO
   Dim lBar As Long
   Dim lInfo As Long
   Dim bChanged As Boolean

   With udtScrInfo
   .cbSize = LenB(udtScrInfo)
   .fMask = SIF_ALL
   API_GetScrollInfo picClient.hwnd, SB_VERT, udtScrInfo
   
   .fMask = SIF_POS  'next Set Call will be in any case POS
   
   'update Thumb Position:
   Select Case wParam
   Case SB_THUMBTRACK
      .nPos = .nTrackPos
      API_SetScrollInfo picClient.hwnd, SB_VERT, udtScrInfo, False
      iTopIndex = .nPos
      UpdateDisplay
'   Case SB_LEFT, SB_BOTTOM
'   Case SB_RIGHT, SB_TOP
   Case SB_LINELEFT, SB_LINEUP
      .nPos = .nPos - 1
      If .nPos >= .nMin Then
         bChanged = True
      End If
   Case SB_LINERIGHT, SB_LINEDOWN
      .nPos = .nPos + 1
      If .nPos <= .nMax - .nPage + 1 Then
         bChanged = True
      End If
   Case SB_PAGELEFT, SB_PAGEUP
      .nPos = .nPos - .nPage
      If .nPos < .nMin Then
         .nPos = .nMin
      End If
      bChanged = True
   Case SB_PAGERIGHT, SB_PAGEDOWN
      .nPos = .nPos + .nPage
      If .nPos > .nMax - .nPage + 1 Then
         .nPos = .nMax - .nPage + 1
      End If
      bChanged = True
'   Case SB_ENDSCROLL
   End Select
   
   If bChanged Then
      API_SetScrollInfo picClient.hwnd, SB_VERT, udtScrInfo, True
      iTopIndex = .nPos
      UpdateDisplay
   End If
   
   End With
End Sub


Public Sub HandleHScrollEvents(wParam As Long, lParam As Long)
Attribute HandleHScrollEvents.VB_MemberFlags = "40"
   Dim udtScrInfo As SCROLLINFO
   Dim lBar As Long
   Dim lInfo As Long
   Dim bChanged As Boolean

   With udtScrInfo
   .cbSize = LenB(udtScrInfo)
   .fMask = SIF_ALL
   API_GetScrollInfo picClient.hwnd, SB_HORZ, udtScrInfo
   
   .fMask = SIF_POS  'next Set Call will be in any case POS
   
   'update Thumb Position:
   Select Case wParam
   Case SB_THUMBTRACK
      .nPos = .nTrackPos
      API_SetScrollInfo picClient.hwnd, SB_HORZ, udtScrInfo, False
      lHScrPos = .nPos
      UpdateDisplay
'   Case SB_LEFT, SB_BOTTOM
'   Case SB_RIGHT, SB_TOP
   Case SB_LINELEFT, SB_LINEUP
      .nPos = .nPos - 1
      If .nPos >= .nMin Then
         bChanged = True
      End If
   Case SB_LINERIGHT, SB_LINEDOWN
      .nPos = .nPos + 1
      If .nPos <= .nMax - .nPage + 1 Then
         bChanged = True
      End If
   Case SB_PAGELEFT, SB_PAGEUP
      .nPos = .nPos - .nPage
      If .nPos < .nMin Then
         .nPos = .nMin
      End If
      bChanged = True
   Case SB_PAGERIGHT, SB_PAGEDOWN
      .nPos = .nPos + .nPage
      If .nPos > .nMax - .nPage + 1 Then
         .nPos = .nMax - .nPage + 1
      End If
      bChanged = True
'   Case SB_ENDSCROLL
   End Select
   
   If bChanged Then
      API_SetScrollInfo picClient.hwnd, SB_HORZ, udtScrInfo, True
      lHScrPos = .nPos
      UpdateDisplay
   End If
   
   End With

End Sub

Public Sub HandlePaintEvent()
Attribute HandlePaintEvent.VB_MemberFlags = "40"
'repaint the display, that means every (visible) line of the list
'is reprinted into the picbox.
'this Function is executed when a WM_PAINT Message is recieved (e.g by calling
'picClient.refresh).
'note that a WM_PAINT Message is first passed to the original WinProc by the
'Event Handler and afterwards .HandlePaintEvent is executed, that means that when
'.HandlePaintEvent is executed, the Picturebox is allready cleared from all old Text that
'was printed in it.
   Dim i As Integer
   Dim iCurX As Integer
   
   picClient.CurrentY = 0
   iCurX = -lHScrPos * iCharWidth
    
   For i = iTopIndex To iListCount - 1
      picClient.CurrentX = iCurX
        
      If i = iListIndex Then
         draw_SELECTOR
      End If
      print_in_COLOR oList(i).ColorText
    
      ' no need to print items that aren't visible:
      If picClient.CurrentY > iWorkingHeight Then
         Exit For
      End If
   Next i
End Sub



' #### #### ##  ##       #### ## ## ##  ##  ###  ###### ##  ###  ##  ##  ###
'##    ##    ####        ##   ## ## ### ## ## ##   ##   ## ## ## ### ## ##
'## ## ###    ##         ###  ## ## ### ## ##      ##   ## ## ## ### ##  ##
'##  # ##    ####        ##   ## ## ## ### ## ##   ##   ## ## ## ## ###   ##
' #### ##   ##  ##       ##    ###  ##  ##  ###    ##   ##  ###  ##  ## ###

Private Sub print_in_COLOR(sExpr As String)
'Writes the Text into the Picturebox

   Dim sExprArray() As String
   Dim vTemp As Variant
   Dim bNextIsColor As Boolean

   sExprArray = Split(sExpr, "\")

   picClient.ForeColor = ClientForeColor

   For Each vTemp In sExprArray
      If vTemp = "" Then
         If bNextIsColor = False Then
            'string starts with "\"
            bNextIsColor = True
         Else
            'was "\\"
            bNextIsColor = False
            picClient.Print "\";
         End If
      Else
         If bNextIsColor = False Then
            picClient.Print vTemp;
            bNextIsColor = True
         Else
            picClient.ForeColor = Val("&H" & vTemp & "&")
            bNextIsColor = False
         End If
      End If
   Next
      
   picClient.Print   ' just new line.

End Sub


Private Sub draw_SELECTOR()
' Draws item selector of selected
' list item:
    Dim iOriginalX As Single
    Dim iOriginalY As Single
    
    ' remember original current X/Y:
    iOriginalX = picClient.CurrentX
    iOriginalY = picClient.CurrentY
    
   If picHighlight Is Nothing Then
      picClient.Line (0, iOriginalY)-(iWorkingWidth, iOriginalY + iCharHeight - 1), HighlightColor, BF
   Else
      API_BitBlt picClient.hdc, 0, picClient.CurrentY, picClient.ScaleWidth, iCharHeight, hdc, 0, picClient.CurrentY, vbSrcCopy
   End If
    
    ' restore original current X/Y:
    picClient.CurrentX = iOriginalX
    picClient.CurrentY = iOriginalY
End Sub

Private Sub remove_SELECTOR()
    Dim iOriginalX As Single
    Dim iOriginalY As Single

    ' remember original current X/Y:
    iOriginalX = picClient.CurrentX
    iOriginalY = picClient.CurrentY

   If picClient.Picture = 0 Then
      picClient.Line (0, iOriginalY)-(iWorkingWidth, iOriginalY + iCharHeight - 1), ClientBackColor, BF
   Else
      picClient.PaintPicture picClient, 0, picClient.CurrentY, , iCharHeight, 0, picClient.CurrentY, , iCharHeight
   End If

    ' restore original current X/Y:
    picClient.CurrentX = iOriginalX
    picClient.CurrentY = iOriginalY
End Sub











'sorting


Private Sub VBQuickSort(AnArray() As clsItem, ByVal LB&, ByVal UB&, SortCriteria As SortCriteria)
  Dim P1&, P2&
  Dim Ref As clsItem
  Dim TEMP As clsItem

    P1 = LB
    P2 = UB
    Set Ref = AnArray(Int((P1 + P2) / 2))
     
     
    Do
      If SortCriteria = CListSortByTag Then
         If TypeName(Ref.Tag) = "String" Then
            Do While StrComp(AnArray(P1).Tag, Ref.Tag, vbTextCompare) = -1
               P1 = P1 + 1
            Loop
 
            Do While StrComp(AnArray(P2).Tag, Ref.Tag, vbTextCompare) = 1
               P2 = P2 - 1
            Loop
         Else
            Do While AnArray(P1).Tag < Ref.Tag
               P1 = P1 + 1
            Loop
 
            Do While AnArray(P2).Tag > Ref.Tag
               P2 = P2 - 1
            Loop
         End If
      Else
         Do While StrComp(AnArray(P1).Text, Ref.Text, vbTextCompare) = -1
            P1 = P1 + 1
         Loop
 
         Do While StrComp(AnArray(P2).Text, Ref.Text, vbTextCompare) = 1
            P2 = P2 - 1
         Loop
      End If

      If P1 <= P2 Then
        Set TEMP = AnArray(P1)
        Set AnArray(P1) = AnArray(P2)
        Set AnArray(P2) = TEMP
            
        P1 = P1 + 1
        P2 = P2 - 1
      End If
    Loop Until (P1 > P2)

    If LB < P2 Then Call VBQuickSort(AnArray(), LB, P2, SortCriteria)
    If P1 < UB Then Call VBQuickSort(AnArray(), P1, UB, SortCriteria)
End Sub

